#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var commander_1 = __importDefault(require("commander"));
var figlet_1 = __importDefault(require("figlet"));
var chalk_1 = __importDefault(require("chalk"));
var recursive_readdir_async_1 = __importDefault(require("recursive-readdir-async"));
var ora_1 = __importDefault(require("ora"));
var collect_1 = require("./helpers/collect");
var isHidden_1 = require("./helpers/isHidden");
var spinner = ora_1.default();
var pkg = require(path_1.default.join(__dirname, '../package.json'));
commander_1.default
    .version(pkg.version)
    .description(pkg.description)
    .usage('[options]')
    .option('-r, --recursive', 'output result including files from subdirectories')
    .option('-x, --exclude [dirs ...]', 'output result without given files & directories', collect_1.collect, [])
    .option('-i, --include [dirs ...]', 'output result for given files & directories', collect_1.collect, [])
    .action(function (_a) {
    var _b = _a.recursive, recursive = _b === void 0 ? false : _b, exclude = _a.exclude, include = _a.include;
    return __awaiter(void 0, void 0, void 0, function () {
        var files, hiddenFiles, visibleFiles, visibleDirs, hiddenDirs, allFiles, allDirs;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    spinner.start('Checking directories');
                    return [4 /*yield*/, recursive_readdir_async_1.default.list('.', {
                            ignoreFolders: false,
                            recursive: recursive,
                            exclude: exclude,
                            include: include,
                        })];
                case 1:
                    files = _c.sent();
                    spinner.stop();
                    hiddenFiles = [];
                    visibleFiles = [];
                    visibleDirs = [];
                    hiddenDirs = [];
                    files.map(function (file) {
                        if (file.isDirectory) {
                            if (isHidden_1.isHidden(file.fullname)) {
                                hiddenDirs.push(file);
                            }
                            else {
                                visibleDirs.push(file);
                            }
                        }
                        else {
                            if (isHidden_1.isHidden(file.fullname)) {
                                hiddenFiles.push(file);
                            }
                            else {
                                visibleFiles.push(file);
                            }
                        }
                    });
                    allFiles = visibleFiles.length + hiddenFiles.length;
                    allDirs = visibleDirs.length + hiddenDirs.length;
                    console.log(chalk_1.default.bold.cyan("Files:\n") +
                        chalk_1.default.cyanBright("Visible: " + visibleFiles.length + "\n" +
                            ("Hidden: " + hiddenFiles.length + "\n") +
                            ("All: " + allFiles)));
                    console.log('');
                    console.log(chalk_1.default.bold.green("Directories:\n") +
                        chalk_1.default.greenBright("Visible: " + visibleDirs.length + "\n" +
                            ("Hidden: " + hiddenDirs.length + "\n") +
                            ("All: " + allDirs)));
                    console.log('');
                    console.log(chalk_1.default.bold.yellow("Summed up:\n") +
                        chalk_1.default.yellowBright("Visible: " + (visibleFiles.length + visibleDirs.length) + "\n" +
                            ("Hidden: " + (hiddenFiles.length + hiddenDirs.length) + "\n") +
                            ("All: " + (allFiles + allDirs))));
                    return [2 /*return*/];
            }
        });
    });
});
commander_1.default.on('--help', function () {
    console.log(chalk_1.default.red(figlet_1.default.textSync('Count CLI', { horizontalLayout: 'full' })));
});
commander_1.default.parse(process.argv);
